/*
 * asm.h --
 *
 *	Definiciones usadas para ensamblar y desensamblar instrucciones DLXV.
 *
 * Copyright 1989 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

#ifndef _ASM_HDR
#define _ASM_HDR

/*
 * Variables y procedimientos exportados al resto del simulador:
 */

extern char *Asm_RegNames[];

extern long int	Asm_Assemble();
extern long int	Asm_AsmCmd();
extern char *	Asm_Disassemble();
extern long int	Asm_GetExpr();
extern long int	Asm_LoadCmd();

#endif /* _ASM_HDR */
