/*
 * lstwin.cpp --
 *
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/


#include <alloc.h>
#include "listwin.h"


TLista::TLista(PTWindowsObject AParent, int AnId, int X, int Y,
		   int W, int H)
	 : TListBox(AParent, AnId, X, Y, W, H)
{
  Attr.Style ^= WS_BORDER;
  Attr.Style |= WS_HSCROLL | LBS_WANTKEYBOARDINPUT | LBS_HASSTRINGS | LBS_USETABSTOPS;
}

void TListWin::WMVkeyToItem(RTMessage Msg)
{

	DefWndProc(Msg);

	if ((Msg.WParam == VK_RETURN) || (Msg.WParam == VK_SPACE))
	{
	char	*Cadena1 = NULL;
	char	*Cadena2 = NULL;

	Lista->GetSelString(Seleccion, TAMSEL);
	Cadena1 = _fstrchr(Seleccion, '('); Cadena1++;
	Cadena2 = _fstrdup(Cadena1);
	Cadena1 = _fstrchr(Cadena2, ')');
	Cadena1 = '\0';
	Linea = atoi(Cadena2) - 1;
	farfree(Cadena2);
	Cadena1 = NULL;
	Result = _fstrchr(Seleccion, '>');
	Result++; Result++;
	SendMessage( Parent->HWindow, WM_FICHEROS, 0L, 0L);
	}
}



TListWin::TListWin(PTWindowsObject AParent, LPSTR Titulo, int X, int Y, int W, int H)
	:TWindow(AParent, Titulo)
	{

	Attr.X = X;
	Attr.Y = Y;
	Attr.W = W;
	Attr.H = H;
	Attr.Id = 888;

	Lista = new TLista(this, 777, 0, 0, Attr.W, Attr.H);
	Result = NULL;

	}

void TListWin::IDSel(RTMessage Msg)
	{

	DefWndProc(Msg);

	if (HIWORD(Msg.LParam) == LBN_DBLCLK)
	{
	char	*Cadena1 = NULL;
	char	*Cadena2 = NULL;

	Lista->GetSelString(Seleccion, TAMSEL);
	Cadena1 = _fstrchr(Seleccion, '('); Cadena1++;
	Cadena2 = _fstrdup(Cadena1);
	Cadena1 = _fstrchr(Cadena2, ')');
	Cadena1 = '\0';
	Linea = atoi(Cadena2) - 1;
	farfree(Cadena2);
	Cadena1 = NULL;
	Result = _fstrchr(Seleccion, '>'); Result++; Result++;
	SendMessage( Parent->HWindow, WM_FICHEROS, 0L, 0L);
	}
	}

void TListWin::WMPaint(RTMessage Msg)

	{
	 RECT Coord;

	 GetClientRect( HWindow, &Coord);

	 MoveWindow( Lista->HWindow,
                Coord.left,
                Coord.top,
                Coord.right - Coord.left,
		Coord.bottom - Coord.top,
		TRUE);

	 DefWndProc(Msg);
         }

void TListWin::WMSize(RTMessage Msg)

	{
	 RECT Coord;

	 GetClientRect( HWindow, &Coord);

	 MoveWindow( Lista->HWindow,
                Coord.left,
                Coord.top,
                Coord.right - Coord.left,
		Coord.bottom - Coord.top,
		TRUE);

	 DefWndProc(Msg);
         }

void TListWin::WMSetFocus(RTMessage Msg)

	{
	 DefWndProc(Msg);
	 SetFocus(Lista->HWindow);
	}
